\input Head

\section{\tt Symlet}

% A short (preferably one-line) description of {\tt MyClass}.

\label{class_symlet}

{\tt Symlet} - defines methods specific for wavelet type Symlet.

\subsection{User Interface}

% % The class definition from the header file

\begin{verbatim}

template<class DataType_t>
class Symlet : public WaveDWT<DataType_t>
{
   private:

      //: forward LP filter coefficients.
      double *pLForward;
      //: inverse LP filter coefficients.
      double *pLInverse;
      //: forward LP filter coefficients.
      double *pHForward;
      //: inverse LP filter coefficients.
      double *pHInverse;

      void setFilter();

   public:

      //: construct from base class
      Symlet(const Wavelet &);

      //: copy constructors
      Symlet(const Symlet<DataType_t> &);

      //: construct from wavelet parameters
      Symlet(int order=4, int tree=0, enum BORDER border=B_CYCLE);

      //: destructor
      virtual ~Symlet();

      //: Duplicate on heap
      virtual Symlet* Clone() const;

      //: decomposition method
      virtual void forward(int level, int layer);
      //: reconstruction method
      virtual void inverse(int level, int layer);

}; // class Symlet

\end{verbatim}

\subsection{Description}

% A longer description of what {\tt MyClass} is used for.

{\tt Symlet} initializes decomposition and reconstruction filters
by values coresponding to specific wavelet of type Symlet.
Class member functions 'forward' and 'inverse' implement
one-step Symlet wavelet transforms.

\subsection{Operating Instructions}

\subsubsection{Example Usage}

% A verbatim block of example code showing proper usage of {\tt
% MyClass}.
\begin{verbatim}

// create data sequence
  Sequence<double> s(n);

// create Symlet wavelet with filter length 10
  Symlet<double> a(10);

// create WaveletUDT object initialzed from sequence and wavelet
  WaveletUDT<double> wu(s,w);

\end{verbatim}


% \subsubsection{Options/Defaults}

% A list of options or defaults for public methods or member data of
% {\tt MyClass}. 


\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

% A list of exceptions thrown by {\tt MyClass}.

None.

\subsubsection{Exceptions Handled}

% A list of exceptions handled by {\tt MyClass}.

None.

\subsection{Algorithms}

% A discussion of the algorithms used by {\tt MyClass}.



\subsection{Accuracy}

% A discussion of issues related to the accuracy of numerical routines
% used by {\tt MyClass}---e.g., approximations,  argument ranges, etc.

Filter coefficients agree with those calculated in Matlab
within $10^{-13}$ in absolute value for filters with length up to 30.

Calculation accuracy taken as maximal difference between
original signal and signal which passed forward and inverse transforms
is about $10^{-11}$ of RMS of original signal for double precision data.
The same difference for float data is about $10^{-6}$.

\subsection{Performance}

% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by {\tt MyClass}.

Performance of one-level routines 'forward' and  'inverse' is linear
($O(N)$) respect to data size $(N)$.

\subsection{Testing}

% A description of any test code/test classes that were used to test
% {\tt MyClass}. 

Tested as part of tWaveletFunctions test.

\subsection{Notes}

% Miscellaneous notes about {\tt MyClass} that do not appear
% elsewhere, things that remain to be done, etc.  

This class is one of several classes implementing different
wavelet transforms such as {\tt Haar}~(\ref{class_haar}),
{\tt Biorthogonal}~(\ref{class_biorthogonal}),
{\tt Daubechies}~(\ref{class_daubechies}). 

\subsection{See Also}

% A list of derived classes, base classes, etc.\ closely related to
% {\tt MyClass}. 

Base class is {\tt WaveDWT}~(\ref{class_wavedwt}).
Other related classes:
{\tt Wavelet}~(\ref{class_wavelet}),
{\tt WaveletUDT}~(\ref{class_waveletudt}).

\subsection{References}

% A list of references for any algorithms, etc.\ used by {\tt
% MyClass}. 

\input Tail


%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 
